#!/usr/bin/env ruby

require 'image'
require 'array_ext'
require 'network'

image_width = image_height = 10
number_of_synapses = image_width * image_height
network = Network.new(number_of_synapses, 4)

images = Image.load(Dir['image-*.png'], image_width, image_height)

i = 0
prev_max_dist = 0
loop do
  i += 1
  $stderr.print "\rобучение... #{i}"
  max_dist = images.map do |image|
               winner = network.learn(image)
               image.data.sub(winner.weights).dist
             end.max
  break if (prev_max_dist - max_dist).abs < 0.001
  prev_max_dist = max_dist
end
puts "\n" + network.neurons.map{|n| "нейрон #{n.id}. #{n.wins.inspect}"}.join("\n")

puts "зашумление..."
images = Image.load(Dir['image-*.png'], image_width, image_height)
images.each do |image|
  (1..10).each do |level|
    new_name = image.filename.gsub('image', "noise-#{level}")
    image.add_noise(level).write(new_name)
  end
end

puts "распознавание..."

(1..10).each do |level|
  puts "\nзашумление #{level*10}%"
  images = Image.load(Dir["noise-#{level}-*.png"], image_width, image_height)
  images.sort.each do |image|
    winner = network.recognize(image)
    puts "#{image.filename}. победитель: #{winner.id}. #{winner.wins.inspect}"
  end
end
