require 'neuron'

class Network
  attr_accessor :neurons
  attr_accessor :speed
  attr_accessor :learn_steps
  attr_accessor :number_of_synapses


  def initialize(number_of_synapses, neurons_count)
    @number_of_synapses = number_of_synapses
    @neurons = Array.new(neurons_count){|i| Neuron.new(i, self) }
    @speed = 1.0 / neurons_count
    @learn_steps = learn_steps
  end

  def learn(input)
    winner = neurons.min{|a,b| a.reaction_on(input) <=> b.reaction_on(input)}
    winner.increase_link_with(input)
    winner
  end

  def recognize(input)
    neurons.min{|a,b| a.reaction_on(input) <=> b.reaction_on(input)}
  end
end
